unit rpiGPIO;

{$mode objfpc}{$H+}

interface

uses
 Classes, SysUtils, Unix, BaseUnix;

procedure gpioSettings(path, v: ansiString);
procedure gpioSetDirection(n: byte; o: boolean);
function gpioRead(n: byte): boolean;
procedure gpioWrite(n: byte; o: boolean);

implementation

procedure gpioSettings(path, v: ansiString);
var
 r: integer;
begin
 try
  r:= FpOpen(pChar('/sys/class/gpio/' + path), O_WrOnly);
  if r > 0 then FpWrite(r, v[1], length(v))
  else raise Exception.Create('Can not open control resource.');
	finally
  FpClose(r);
	end;
end;

procedure gpioSetDirection(n: byte; o: boolean);
const
 v: array [boolean] of pChar = ('in', 'out');
begin
 gpioSettings(pChar('gpio' + IntToStr(n) + '/direction'), v[o]);
end;

function gpioRead(n: byte): boolean;
var
 r: integer;
 ch: char;
begin
 try
  r:= FpOpen('/sys/class/gpio/gpio' + IntToStr(n) + '/value', O_RdOnly);
  if r > 0 then begin
    fpRead(r, ch, 1);
    Result:= ch = '1';
  end else raise Exception.Create('Can not open control resource.');
	finally
  FpClose(r);
	end;
end;

procedure gpioWrite(n: byte; o: boolean);
const
 v: array [boolean] of pChar = ('0', '1');
begin
 gpioSettings(pChar('gpio' + IntToStr(n) + '/value'), v[o]);
end;

end.

